/**************************************************************\
* Copyright (C) 1997 - 2001 Vasile CALMATUI (vasile@wook.com)  *
*                                                              *
* Ce logiciel est du domaine public. Vous avez la permission   *
* d'utiliser, de copier et de modifier ce logiciel.            *
****************************************************************
* Ne me contactez pas SVP pour des informations, bugs,         *
* commentaires, problemes, contributions, offres d'emploi.     *
* Si vous aimez ce logiciel, envoyez une carte postale a       *
* l'adresse suivante :                                         *
* Vasile CALMATUI                                              *
* 35 str. Burebista                                            *
* 3600 Ungheni                                                 *
* MOLDOVA (Moldavie)                                           *
****************************************************************
* L'auteur n'est pas responsable pour les dommages occasionnes *
* par l'utilisation de ce logiciel ou de ses derives.          *
\**************************************************************/

import java.applet.Applet;
import java.awt.*;

public class VasTabulation extends Applet {
  Label l1;
  TextField t1;
  Button b1, b2;
  TextArea ta1;
  Checkbox ck1;
  Choice ch1;
  List ls1;
  //pour passer d'une case a l'autre avec tabulation
  public Component[] compo;

  public String getAppletInfo() {
    return (new String("VasTabulation v1.3, 5 septembre 1998, (C) 1997, 1998, 1999, 2000, 2001 Vasile Calmatui"));
  }

  //constructeur
  public VasTabulation() {
    setLayout(null);
    setBackground(Color.lightGray);
    //on met quelques composants dans l'applet
    l1=new Label("Utilisez Tab/maj+Tab pour changer de champ");
    l1.reshape(5, 10, 280, 25);
    add(l1);
    t1=new TextField("text1");
    t1.reshape(10, 40, 80, 25);
    add(t1);
    ch1=new Choice();
    ch1.addItem("Option1");
    ch1.addItem("Option2");
    add(ch1);
    b1=new Button("Bouton1");
    b1.reshape(210, 40, 70, 30);
    add(b1);
    b2=new Button("Bouton2");
    b2.reshape(10, 80, 70, 30);
    add(b2);
    ls1=new List();
    ls1.addItem("Option1");
    ls1.addItem("Option2");
    add(ls1);
    ck1=new Checkbox("Check1");
    ck1.reshape(210, 80, 80, 30);
    add(ck1);
    ta1=new TextArea();
    ta1.reshape(10, 150, 270, 130);
    ta1.setEditable(false);
    add(ta1);
 
    ta1.appendText("C'est une applet qui permet de passer");
    ta1.appendText("\nd'un composant un autre en utilisant la");
    ta1.appendText("\ntouche de Tabulation ou maj+Tab. Cela");
    ta1.appendText("\nexecutera une action en appuyant sur");
    ta1.appendText("\nEntree quant le focus est sur un bouton.");
    ta1.appendText("\n(C) 1997, 1998, 1999, 2000 Vasile Calmatui");
    resize(290, 290);
  }//fin constructeur

  public void init() {
    //il faut "reshaper" les "list" et les "choice" dans l'init
    ch1.reshape(100, 40, 100, 25);
    ls1.reshape(100, 80, 100, 60);
    //pour passer d'une case a l'autre avec tabulation
    compo=new Component[7];
    compo[0]=t1;
    compo[1]=ch1;
    compo[2]=b1;
    compo[3]=b2;
    compo[4]=ls1;
    compo[5]=ck1;
    compo[6]=ta1;
    compo[0].requestFocus();
    if(compo[0] instanceof TextComponent) ((TextComponent)compo[0]).selectAll();
  }//fin init

  public boolean handleEvent(Event e) {
    //pour passer d'une case a l'autre avec tabulation
    if(e.id==Event.KEY_PRESS && e.key == '\t') {
      for(int i=0; i<compo.length; i++) {
        if(e.target==compo[i]) {
          //en IE4, le texte reste selectionne
          //c'est pas joly, donc on de-selectionne avant de partir
          if(compo[i] instanceof TextComponent) ((TextComponent)compo[i]).select(0, 0);
          //s'il y a un composant "disabled", on passe plus loin
          //merci :-) Jean-Marie GANDON
          do {
            i=(i+(e.shiftDown() ? compo.length-1 : 1))%compo.length;
          } while(!compo[i].isEnabled());
          compo[i].requestFocus();
          if(compo[i] instanceof TextComponent) ((TextComponent)compo[i]).selectAll();
          return true;
        }
      }
      return false;
    }//fin '\t'

    //si "Entree" appuye, ca part
    if(e.target==b1 && (e.arg==b1.getLabel() || (e.id==Event.KEY_RELEASE && e.key=='\n'))) {
      if(b2.isEnabled()) b2.disable();
      else b2.enable();
      return true;
    }//fin b1

    //si "Entree" appuye, ca part
    if(e.target==b2 && (e.arg==b2.getLabel() || (e.id==Event.KEY_RELEASE && e.key=='\n'))) {
      if(b1.isEnabled()) b1.disable();
      else b1.enable();
      return true;
    }//fin b2
    return false;//les autres evenements ne seront pas traites
  }//fin handleEvent

}//fin classe VasTabulation
